unit hiImg_ROP2;

interface

uses Windows,Kol,Share,Img_Draw;

type
  THIImg_ROP2 = class(THIDraw2PR)
   private
    oldROP2: integer;
   public
    _prop_ROP2: integer;
    _data_ROP2: THI_Event;
    _event_onSet: THI_Event;
    _event_onReset: THI_Event;

    constructor Create;
    procedure _work_doSet(var _Data:TData; Index:word);
    procedure _work_doReset(var _Data:TData; Index:word);
    procedure _var_OldROP2(var _Data:TData; Index:word);
    procedure _var_GetROP2(var _Data:TData; Index:word);    
  end;

implementation

constructor THIImg_ROP2.Create;
begin
   inherited Create;
   oldROP2 := -1;
end;

procedure THIImg_ROP2._work_doSet;
var dt: TData;
begin
    dt := _Data;
TRY
    if not ImgGetDC(_Data) then exit;
    OldROP2 := SetROP2(pDC, ReadInteger(_Data,_data_ROP2,_prop_ROP2) + 1);
FINALLY
    ImgReleaseDC;
    _hi_CreateEvent(_Data,@_event_onSet,dt);
END;
end;

procedure THIImg_ROP2._work_doReset;
var dt: TData;
begin
    dt := _Data;
TRY
    if not ImgGetDC(_Data) then exit;
    OldROP2 := SetROP2(pDC, OldROP2);
FINALLY
    ImgReleaseDC;
    _hi_CreateEvent(_Data,@_event_onReset,dt);
END;
end;

procedure THIImg_ROP2._var_OldROP2;
begin
    dtInteger(_data, oldROP2 - 1);
end;

procedure THIImg_ROP2._var_getROP2;
var val: integer;
begin
TRY
    if not ImgGetDC(_Data) then exit;
    val :=  GetROP2(pDC);
FINALLY
    ImgReleaseDC;
    dtInteger(_data, val - 1);
END;
end;

end.