unit hiImg_Line;

interface

{$I share.inc}

uses Windows,Kol,Share,Img_Draw;

type
  THIImg_Line = class(THIImg)
   private
   public
    procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure THIImg_Line._work_doDraw;
var   dt: TData;
      pen: HPEN;
      mPen: PGeometricPen;
      mTransform: PTransform;
begin
   dt := _Data;
TRY
   if not ImgGetDC(_Data) then exit;
   ReadXY(_Data);
   ImgNewSizeDC;

   mPen := ReadObject(_Data, _data_Pen, GEOMETRICPEN_GUID);
   if mPen <> nil then mPen._Set(pDC, x1, y1, FScale) //   
   else
    begin
     pen := CreatePen(ord(_prop_LineStyle), Round((fScale.x + fScale.y) * ReadInteger(_Data,_data_Size,_prop_Size)/2), Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color)));
     SelectObject(pDC,Pen);
    end;
{ --------------------------   ------------------------- }
   mTransform := ReadObject(_Data, _data_Transform, TRANSFORM_GUID);
   if mTransform <> nil then
    if mTransform._Set(pDC,x1,y1,x2,y2) then  //    (rotate, flip)
     PRect(@x1)^ := mTransform._GetRect(MakeRect(x1,y1,x2,y2));
{ -----------------------------   ----------------------------------- }
   MoveToEx(pDC, x1, y1, nil);
   LineTo(pDC, x2, y2);
{ ------------------------------  ------------------------------------ }
   if mTransform <> nil then mTransform._Reset(pDC);  //  
   if mPen = nil then DeleteObject(Pen) else mPen._Delete(pDC); //      
FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onDraw,dt);
END;
end;

end.